# xinfer

## Purpose

You want to design an experiment to measure some parameters $\vec{\theta}$. Your experiment has some parameters $\vec{\xi}$ like geometry, material properties, electronic transfer functions, etc that you can measure and control to varying degrees. You want your experimental outcomes $\vec{\mu}$ to depend sensitively on $\vec{\theta}$. However, any uncertainty in your experimental parameters may lead to a systematic uncertainty in your measurement of $\vec{\theta}$. We want to answer two questions:

1. What choice of experimental parameters maximizes our information about $\vec{\theta}$ after the measurement?
2. Given our uncertainty on the exerimental parameters, what is our systematic uncertainty on $\vec{\theta}$?

## Example

The code in xinfer/optimize starts to answer (1). The code in xinfer/systematics starts to answer (2).

### Experimental setup

We want to infer the mechanical loss angle of a thin film deposited on a silicon mechanical oscillator, which is clamped at its base. In this case the mechanical oscillator consists of a trident-of-tridents, which has the feature that many eigenmodes of its farthest spokes do not involve the clamped region at the base of the oscillator, protecting them from clamping losses.

We can add varying degrees of complexity to this problem, but for now assume the measurement is carried out at a fixed temperature and that the mechanical Q of the overall system is determined by mechanical loss in each of the coating, substrate, and clamping material, weighted by the fraction of an eigenmode's strain-energy in each material domain. The mechanical losses may have a power law frequency dependence.

$\frac{1}{Q} = \frac{E_\mathrm{coating}\phi_\mathrm{coating} + E_\mathrm{substrate}\phi_\mathrm{substrate} + E_\mathrm{clamp} \phi_\mathrm{clamp}}{E_\mathrm{total}}$

Because each material loss contributes to eigenmode quality factor differently depending on mode shape, measuring the quality factor of many eigenmodes can tell us about the mechanical loss in the material of interest, the coating. However, our inability to perfectly predict the strain energy ratios for each eigenmode introduces a systematic error in our estimate of $\phi_\mathrm{coating}$.

To be concrete, our model $A_{\vec{\xi}}$ uses a set of parameters $\vec{\theta}$ to predict eigenfrequency and Q $\vec{\mu}=\{f_i, Q_i\}$ for the first several low-frequency eigenmodes of the mechanical system. 

$\vec{\mu}=A_{\vec{\xi}}(\vec{\theta})$

One member of $\vec{\theta}$ is what we actually want to infer, the mechanical loss of the coating $\phi_\mathrm{coating}$. The other members of $\vec{x}$ are a variety of parameters that we may control only imperfectly (like substrate and coating thickness, or other geometric parameters), along with parameters we can only characterize imperfectly (like Young's modulus of the coating and substrate). $A$ may also depend on some parameters $\vec{\xi}$ with negligible uncertainty that we may or may not be able to control. 

### Inference method to estimate systematic errors

We want to use our measurements of $\vec{\mu}$ and the covariance matrix or joint probability distribution of our measurement, $P_\mathrm{cov}(\vec{\mu})$, to infer $\vec{\theta}$ with the smallest uncertainty on $\phi_\mathrm{coating}$ possible. We can apply Bayes' rule and the assumption that all of our model uncertainty is captured by our uncertainty in members of $\vec{\theta}$ to write

$P_\mathrm{post}(\vec{\theta}|\vec{\mu}) = \frac{P_\mathrm{prior}(\vec{\theta})}{P_\mathrm{cov}(A_{\vec{\xi}}(\vec{\theta}))}$

Our approach will be to use a Metropolis-Hastings algorithm to sample from $P_\mathrm{post}$ by drawing samples from the ratio of the known distributions $P_\mathrm{prior}$ and $P_\mathrm{cov}$.

#### Inference demonstration

The MCMC script (xinfer.py) does the following:
1. Start MATLAB engine and connect to COMSOL server
2. Instantiate COMSOL model of mechanical system
3. Define nominal values of parameters to be inferred (params0) and hyperparameters (hp) of the simulation
    - Currently, params0 contains coating and substrate thickness, plus log10(loss angle) for the coating, substrate, and clamp
    - Hyperparameters include the prior uncertainties on members of params0, which are assumed independent and normal distributed; measurement uncertainties on eigenfrequencies and Qs, also assumed independent and normal distributed; parameters of the MCMC, such as number of walkers and maximum steps to takes
4. Generate and save some fake data for the simulation:
    - The "true" model parameters are drawn from the prior distribution and collected in x0 (labels in p0)
    - Some "experimental data" (data) are generated by running the experimental model on x0 (returns y0, the expected outcome of the experiment given x0) then adding noise to each of the measurement values in y0.
    - theta0, the starting positions of the MCMC walkers, are generated by drawing from the prior distribution
5. Set up the MCMC sampler
    - Tell emcee.EnsembleSampler how many walkers to use, dimension of parameters space, posterior distribution function, and any necessary kwargs for the posterior function
    - Includes a "backend," which lets us save MCMC progress in case it unexpectedly crashes
6. Run MCMC sampler
    - Every 25 iterations (so each walker calls the posterior function 25 times), check whether the sampler has converged. Convergence is measured by the autocorrelation function of walker position being 100x shorter than the total number of iterations completed (such that theta0 has been "forgotten" by the walkers, whose positions should now only depend on the posterior distribution).
7. Disconnect from COMSOL server

### Experimental Design Optimization

This text describes the cost function of xopt.py, which implements the relevant derivatives, linear algebra, and marginalization described below in helpers.py starting with the function $U_\mathrm{FIG}$.

Bayesian experimental design seeks to choose $\vec{\xi}$ to maximize the expected information gain of $P_\mathrm{post}$ over $P_\mathrm{prior}$. However, repeatedly evaluating the posterior is computationally expensive (requiring, as described above, at least 1 and possibly 2 nested MCMC).

The classical Fisher information matrix is simple to compute for several well known cases, and can be used to construct a measure of expected information gain that is consistent with the fully Bayesian approach under some palatable assumptions (basically, that systematic uncertainties are less important than statistical ones over the relevant prior).

First, we can choose variables with normal probability distributions to simplify calculation:
-  $\vec{\theta}$ are log(loss angles). We expect measurement uncertainty on Q or loss angle to be log-normal.
-  $\vec{\mu}$ are $\ln(1/Q)$, again because we expect these to be log-normal.
-  $\vec{\xi}$ are the strain energy ratio weights applied to each domain, which vary by eigenmode and are determined by the full experimental parameters and finite element analysis.

These definitions lead to a standard regression problem in the primed coordinates

$e^{\mu_i'} = \sum_{j} \xi_{ij}'e^{\theta_{j}'}$

The fisher information matrix for observations with a multivariate normal distribution $N(\vec{\mu}'(\vec{\theta}'), \Sigma(\theta'))$ takes the form (from wikipedia)

$\mathcal{I}_{m,n} = \frac{\partial\mu^\top}{\partial\theta_m}\Sigma^{-1}\frac{\partial\mu}{\partial\theta_n} + \frac{1}{2}\mathrm{tr}(\Sigma^{-1}\frac{\partial\Sigma}{\partial\sigma_m}\Sigma^{-1}\frac{\partial\Sigma}{\partial\theta_n})$

The Fisher information matrix roughly describes the sensitivity of the full posterior to $\vec{\theta}$. However, we only want to measure the coating loss angle, $\theta_\mathrm{coating}=\ln(\phi_\mathrm{coating})$, and don't care if we precisely measure the intrinsic loss angle of the clamping material (for example). Inverting the Fisher information and selecting just the on-diagonal element corresponding to variance on $\theta_\mathrm{coating}$ gives us an objective function. Finally, we average over our prior distribution on $\vec{\theta}$ to approach the Bayesian expected information gain.

## How to run

### Guide to the files

- models contains various comsol FEA models. For example, oneSided_Ge_coarse.m is of a trident-of-tridents mechanical oscillator. The bulk of the oscillator is <100> crystalline silicon, it is coated with a thin film of some material of interest (in this case, germanium). I added a steel clamping block to the base of the oscillator, and constrained the ends of the steel block. The purpose of the model is to compute the strain energy in the clamp, silicon, and coating for each of several eigenmodes of the system.
- src contains helpers.py (with most of the python functions) and several .m files that are called by the matlab engine
- systematics contains the inference problem described above. xinfer.py is the main script that performs a MCMC to determine the distribution of x in the experimental parameters. An example of a corner plot is in xinfer.ipynb (rough).
- optimize contains the experimental design problem described above. xopt.py is the main script that iterates over resonator geometry to maximize expected information gained about the coating mechanical loss.

### Requirements and installation

Though the python package requirements can be found in the .yml file, running COMSOL from python requires calling a MATLAB engine capable of interfacing with a COMSOL server session. Here is a description of my setup that is currently working:

1. COMSOL Multiphysics 6.0 running COMSOL Multiphysics server
2. MATLAB R2021b with python engine installed
3. Python 3.8.5

You can set up the conda environment with 
`conda env create -f xinfer.yml'

Then, install the repo in the new conda environment
```
conda activate xinfer
pip install -e .
```

#### Installing python engine for MATLAB

The best system-dependent instructions are on [mathworks' git repo for their python engine](https://github.com/mathworks/matlab-engine-for-python/). 

You can check the simplified instructions [from MathWorks](https://www.mathworks.com/help/matlab/matlab_external/install-the-matlab-engine-for-python.html), but they are somewhat misleading. You likely need to specify matlabengine version during installation, as described [on stackexchange](https://stackoverflow.com/questions/73972913/how-to-install-matlabengine-windows-10-matlab-r2020b-python-3-8-10). 

### Running optimize

1. Start COMSOL server, preferably in a detachable screen or tmux session
    - `comsol mphserver -login force -port 2020`
    - enter a simple user and password that you don't mind appearing in plaintext. I used 'whoever' with password 'whatever'
    - You can also avoid entering the credentials after the first time with `comsol mphserver -login never -multi on`
2. In a different tmux session, `python xopt.py` 

### Running systematics (MCMC simulation)

1. Start COMSOL server, preferably in a detachable screen or tmux session
    - `comsol mphserver -login force -port 2020`
    - enter a simple user and password that you don't mind appearing in plaintext. I used 'whoever' with password 'whatever'
    - You can also avoid entering the credentials after the first time with `comsol mphserver -login never -multi on`
2. `python xinfer.py` 
    - The script will print the randomly selected "true" values of the experimental parameters before running MCMC. You'll get an error if they fall outside of the prior bounds, but you may want to ensure they are satisfactory before letting your simulation run too long.
